
import bpy
from sys import *
import os, subprocess
from string import *
from math import pi, cos, sin, tan, atan, degrees, radians

scene= bpy.context.scene


ostype = platform
GLOBALS = {}
defaultDir=''
blendFileName=''



octaneCameraMotion=0
octaneNativeUnitSize=3
octaneActiveCamera=''
octaneAnimationStart=1
octaneAnimationEnd=250
octaneAnimationStep=1





def matrix_vect(mat,vec):
	vecr = [0.,0.,0.,0.,0.]
	for i in range(4):
		for j in range(4):
			vecr[i] += vec[j] * mat[j][i] 
	return vecr
		
def rotate90x(vect):
	return [vect[0],vect[2],-vect[1]]
	





def write_command(filename,frame):
	file = open(filename,"w")
	#Set the unit factor
	unitFactor = {
		0:0.001,
		1:0.01,
		2:0.1,
		3:1,
		4:10,
		5:100,
		6:1000,
		7:0.0254,
		8:0.3048,
		9:0.9144,
		10:201.168,
		11:1609.344               
	}[octaneNativeUnitSize]
	scene_frames = range(octaneAnimationStart, octaneAnimationEnd+1,octaneAnimationStep) 
	camera_param = ''
	axes = ['x','y','z']
	octaneActiveCamera="Octane"
	
		



	currentCameraObj = bpy.data.objects[bpy.context.active_object.name]
	camera = currentCameraObj

	
	for frame in scene_frames:
  
		scene.frame_set(frame)
		cameradata = bpy.data.objects["Camera"]
		hfov = degrees(cameradata.data.angle)
		vfov = degrees(2 * atan(tan(hfov/2) * (14.9/22.3)))
		dof = cameradata.data.dof_distance
        
      #  hfov = radians(cameradata.data.angle)
     #   vfov = degrees(2 * atan(tan(hfov/2) * (14.9/22.3)))



	

		matrix = camera.matrix_world.copy()
  
		position = rotate90x(matrix_vect(matrix,[0.0,0.0,0.0,1.0]))
		target = rotate90x(matrix_vect(matrix,[0.0,0.0,-1.0,1.0]))
		up = rotate90x(matrix_vect(matrix,[0.0,1.0,0.0,0.0]))
		
		for i in range(3):
			camera_param += "#%f" % (position[i]*unitFactor)
		for i in range(3):
			camera_param += "#%f" % (target[i]*unitFactor)
		camera_param += "#%f" % (hfov)
		for i in range(3):
			camera_param += "#%f" % (up[i]*unitFactor)
		camera_param += "#%f" % (dof*unitFactor)

			
			
		new = camera_param.replace('#', '', 1)
		file.write(new)
		file.write("\n")
		camera_param = ""
		

	file.close()			
				

				
octcam = 'OctaneCamera.txt'
write_command(octcam, 1)
